<?php

namespace Feedbii\DataCollector;


/**
 * Class Order
 * @package Feedbii\DataCollector
 */
class Order extends AbstractDataCollector implements DataCollectorInterface
{

    /**
     * @return array
     */
    public function getOrders()
    {
        $sql='
        SELECT
         c.commande_id
        , c.client_id
        , DATE_FORMAT(c.commande_date_ajout, "%Y-%m-%d") as date
        , csn.commande_statut_nom_nom as status
        , "" as canal_vente
        , c.commande_referer as canal_clic
        , SUM(IF(cpa.commande_produit_attribut_id IS NULL,cp.produit_quantite,cpa.produit_option_valeur_quantite)) as nb_produit
        , c.commande_stotal_ht as stotal_ht
        , c.commande_stotal_ttc as stotal_ttc
        , c.commande_port_ht as port_ht
        , c.commande_total_taxe as total_taxe
        , c.commande_total_ht as total_ht
        , c.commande_total_ttc as total_ttc
        , "" as marketplace_id
        , "" as canal_vente
        , "" as marketplace_comission
        , "" as cout_expedition
        , c.paiement_nom as paiement
        , SUM(IF(cp.produit_id IS NULL, cp.produit_total_ht, 0)) as remise_total_ht
        , SUM(IF(cpa.commande_produit_attribut_id IS NULL,cp.produit_achat*cp.produit_quantite,cpa.produit_option_valeur_achat*cpa.produit_option_valeur_quantite)) as total_achat_ht
        , tr.tpe_reference_id as transaction_id
         FROM commande c
         LEFT JOIN commande_produit cp ON (c.commande_id = cp.commande_id)
         LEFT JOIN tpe_reference tr ON (c.commande_id = tr.commande_id)
         LEFT JOIN commande_produit_attribut cpa ON (cpa.commande_produit_id = cp.commande_produit_id)
         LEFT JOIN commande_statut_nom csn ON (csn.commande_statut_id = c.commande_statut_id AND csn.langue_id = '.$_SESSION['langue_id'].')
         WHERE 1
         AND DATE(c.commande_date_ajout) >= "'.$this->getDateFrom()->format('Y-m-d').'"
         AND DATE(c.commande_date_ajout) <= "'.$this->getDateTo()->format('Y-m-d').'"
         GROUP BY c.commande_id
         ';
        $this->db->query($sql, SQL_ALL, SQL_ASSOC);
        $result = $this->db->record;
        if (!$result){
            echo mysqli_error($this->db)."<br/>";
        }

        $arrCommande = array();

        foreach($result as $row) {
            array_push($arrCommande, $row);
        }

        foreach ($arrCommande as $k => $commande){
            $arrCommande[$k]['paiement'] = (string)$commande['paiement'];
            $arrCommande[$k]['status'] = (string)$commande['status'];
            $arrCommande[$k]['nb_produit'] = (int)$arrCommande[$k]['nb_produit'];
            $arrCommande[$k]['stotal_ht'] = (float)$arrCommande[$k]['stotal_ht'];
            $arrCommande[$k]['stotal_ttc'] = (float)$arrCommande[$k]['stotal_ttc'];
            $arrCommande[$k]['port_ht'] = (float)$arrCommande[$k]['port_ht'];
            $arrCommande[$k]['total_taxe'] = (float)$arrCommande[$k]['total_taxe'];
            $arrCommande[$k]['total_ht'] = (float)$arrCommande[$k]['total_ht'];
            $arrCommande[$k]['total_ttc'] = (float)$arrCommande[$k]['total_ttc'];
            $arrCommande[$k]['marketplace_id'] = (int)$arrCommande[$k]['marketplace_id'];
            $arrCommande[$k]['marketplace_comission'] = (float)$arrCommande[$k]['marketplace_comission'];
            $arrCommande[$k]['cout_expedition'] = (float)$arrCommande[$k]['cout_expedition'];
            $arrCommande[$k]['remise_total_ht'] = (float)$arrCommande[$k]['remise_total_ht'];
            $arrCommande[$k]['total_achat_ht'] = (float)$arrCommande[$k]['total_achat_ht'];
            $arrCommande[$k]['transaction_id'] = (int)$arrCommande[$k]['transaction_id'];
            $arrCommande[$k]['client_id'] = (int) $arrCommande[$k]['client_id'];
            $arrCommande[$k]['commande_id'] = (int) $arrCommande[$k]['commande_id'];
        }
        return $arrCommande;
    }

    /**
     * @return array
     */
    public function getProducts()
    {
        $sql='SELECT
         c.commande_id, c.commande_port_ht
        , DATE_FORMAT(c.commande_date_ajout, "%Y-%m-%d") as date
        , c.paiement_nom as paiement
        , csn.commande_statut_nom_nom as status
         FROM (commande c)
         LEFT JOIN commande_statut_nom csn ON (csn.commande_statut_id = c.commande_statut_id AND csn.langue_id = '.$_SESSION['langue_id'].')
         WHERE 1
        AND DATE(c.commande_date_ajout) >= "'.$this->getDateFrom()->format('Y-m-d').'"
        AND DATE(c.commande_date_ajout) <= "'.$this->getDateTo()->format('Y-m-d').'"
        GROUP BY c.commande_id
        ';

        $this->db->query($sql, SQL_ALL, SQL_ASSOC);
        $result = $this->db->record;

        if (!$result){
            echo mysqli_error($this->db)."<br/>";
        }

        $arrCommande = array();
        foreach($result as $row) {
            $sql = "SELECT cp.produit_id";
            $sql.=", IF(commande_produit_attribut_id IS NULL,cp.produit_quantite,cpa.produit_option_valeur_quantite) AS qte";
            $sql.=", IF(commande_produit_attribut_id IS NULL,cp.produit_achat,cpa.produit_option_valeur_achat) AS achat_ht";
            $sql.=", IF(cp.produit_id IS NULL,cp.produit_ref,p.produit_ref) as produit_ref";
            $sql.=", IF(cp.produit_id IS NULL,cp.produit_nom,pn.produit_nom_nom) as produit_nom";
            $sql.=", IF(cp.produit_id IS NULL,'',m.marque_nom) as marque_nom";
            $sql.=", ROUND(IF(commande_produit_attribut_id IS NULL,cp.produit_prix,cp.produit_prix+cpa.produit_option_valeur_prix),2) AS prix_ht";
            $sql.=", ROUND(IF(commande_produit_attribut_id IS NULL,cp.produit_total_ht,((cp.produit_prix+cpa.produit_option_valeur_prix)*cpa.produit_option_valeur_quantite)),2) AS prix_total_ht";
            $sql.=" FROM (commande_produit cp)";
            $sql.=" LEFT JOIN commande_produit_attribut cpa ON (cp.commande_produit_id = cpa.commande_produit_id)";
            $sql.=" LEFT JOIN produit p ON (p.produit_id = cp.produit_id)";
            $sql.=" LEFT JOIN produit_nom pn ON (p.produit_id = pn.produit_id AND langue_id = 1)";
            //Multimarque
//            $sql.=" LEFT JOIN produit_marque pm ON (pm.produit_id = p.produit_id)";
//            $sql.=" LEFT JOIN marque m ON (pm.marque_id = m.marque_id)";
            //Multimarque
            // mono parque
            $sql.=" LEFT JOIN marque m ON (p.marque_id = m.marque_id)";
            $sql.=" WHERE cp.commande_id = ".$row['commande_id'];
            $sql.=" GROUP BY cp.commande_produit_id";
            $this->db->query($sql, SQL_ALL, SQL_ASSOC);
            $result2 = $this->db->record;
            foreach($result2 as $row2) {
                $row2['commande_id'] = $row['commande_id'];
                $row2['date'] = $row['date'];
                $row2['port_ht'] = $row['commande_port_ht'];
                $row2['status'] = $row['status'];
                $row2['paiement'] = $row['paiement'];
                array_push($arrCommande, $row2);
            }

        }


        $arrCommandeProduct = array();
        foreach ($arrCommande as $k => $commande){
            $arrCommandeProduct[$k] = array();
            $arrCommandeProduct[$k]['commande_id'] = (int)$commande['commande_id'];
            $arrCommandeProduct[$k]['date'] = $commande['date'];
            $arrCommandeProduct[$k]['produit_id'] = (int)$commande['produit_id'];
            $arrCommandeProduct[$k]['qte'] = (int)$commande['qte'];
            $arrCommandeProduct[$k]['achat_ht'] = (float)$commande['achat_ht'];
            $arrCommandeProduct[$k]['port_ht'] = (float)$commande['port_ht'];
            $arrCommandeProduct[$k]['prix_ht'] = (float)$commande['prix_ht'];
            $arrCommandeProduct[$k]['total_ht'] = (float)$commande['prix_total_ht'];
            $arrCommandeProduct[$k]['produit_ref'] = $commande['produit_ref'];
            $arrCommandeProduct[$k]['produit_nom'] = $commande['produit_nom'];
            $arrCommandeProduct[$k]['marque'] = $commande['marque_nom'];
            $arrCommandeProduct[$k]['paiement'] = $commande['paiement'];
            $arrCommandeProduct[$k]['status'] = $commande['status'];
            if(!empty($commande['produit_id'])) {
                if(!empty($commande['marque_nom'])) {
                    $arrCommandeProduct[$k]['url'] = generateURL('page=produit&produit_nom='.parseURL($commande['produit_nom']).'&marque_nom='.parseURL($commande['marque_nom']).'&id='.$commande['produit_id']);
                } else {
                    $arrCommandeProduct[$k]['url'] = generateURL('page=produit&produit_nom='.parseURL($commande['produit_nom']).'&id='.$commande['produit_id']);
                }
            } else {
                $arrCommandeProduct[$k]['url'] = '';
            }

            $sql = "SELECT categorie_id FROM produit_categorie WHERE produit_id = '".$commande['produit_id']."'";
            $this->db->query($sql, SQL_INIT, SQL_ASSOC);
            $list_cat = $this->db->record;
            if(!empty($list_cat))
            {
                foreach($list_cat as $categorie_id)
                {
                    $sql = "SELECT parent_id FROM categorie WHERE categorie_id = ".$categorie_id;
                    $this->db->query($sql, SQL_INIT, SQL_ASSOC);
                    $res = $this->db->record;
                    if(!empty($res['parent_id'])) {
                        $parent_id = $res['parent_id'];
                    } else {
                        $parent_id = '';
                    }
                    if(!empty($parent_id) && $parent_id != 'NULL') {
                        while(!empty($parent_id) && $parent_id != 'NULL') {
                            $categorie_id = $parent_id;
                            $sql = "SELECT parent_id FROM categorie WHERE categorie_id = ".$categorie_id;
                            $this->db->query($sql, SQL_INIT, SQL_ASSOC);
                            $res = $this->db->record;
                            if(!empty($res['parent_id'])) {
                                $parent_id = $res['parent_id'];
                            } else {
                                $parent_id = '';
                            }
                        }
                    }

                    $sql = "SELECT categorie_nom_nom FROM categorie_nom WHERE langue_id = 1 AND  categorie_id = '".$categorie_id."'";
                    $this->db->query($sql, SQL_INIT, SQL_ASSOC);
                    $arrCommandeProduct[$k]['categorie'][] = $this->db->record['categorie_nom_nom'];
                }
            }
        }

        return $arrCommandeProduct;
    }

    /**
     * @return array
     */
    public function getStatus()
    {

        $sql='
        SELECT
         c.commande_id
        , DATE_FORMAT(c.commande_statut_historique_date_ajout, "%Y-%m-%d") as date
		, MAX(commande_statut_historique_id) as maxid
         FROM (commande_statut_historique c)
        WHERE 1
        AND DATE(c.commande_statut_historique_date_ajout) >= "'.$this->getDateFrom()->format('Y-m-d').'"
        AND DATE(c.commande_statut_historique_date_ajout) <= "'.$this->getDateTo()->format('Y-m-d').'"
        GROUP BY c.commande_id
        ORDER BY c.commande_statut_historique_date_ajout DESC
        ';

        $this->db->query($sql, SQL_ALL, SQL_ASSOC);
        $result = $this->db->record;

        if (!$result){
            echo mysqli_error($this->db)."<br/>";
        }

        $arrCommande = array();

        foreach($result as $row) {
            array_push($arrCommande, $row);
        }


        foreach ($arrCommande as $k => $commande){


            $sql='
                SELECT
                osl.commande_statut_nom_nom as status
                FROM commande_statut_historique oh
                LEFT JOIN commande_statut_nom osl ON
                (oh.commande_statut_id = osl.commande_statut_id AND osl.langue_id = '.$_SESSION['langue_id'].')
                WHERE oh.commande_statut_historique_id = '.(int)$commande['maxid'].'
                GROUP BY oh.commande_statut_historique_id
            ';
            $this->db->query($sql, SQL_ALL, SQL_ASSOC);
            $result = $this->db->record;

            $state = array();

            foreach ($result as $row) {
                array_push($state, $row);
            }
            $arrCommande[$k]['commande_id'] = (int) $arrCommande[$k]['commande_id'];
            $arrCommande[$k]['status'] = (string)$state[0]['status'];

        }
        return $arrCommande;
    }
}